/**
  Google Reader Notifier
  By Mark D.B.D <markdbd@gmail.com>
  http://www.markdbd.com
**/

var GrPref =
{

	/**
	* @var mixed Preferencias en firefox
	*/

	prefs: null,

	/**
	* @var int Intervalo por defecto
	*/

	defaultInterval: null,

	/**
	* @var mixed passwordManager
	*/

	passwordManager: null,

	/**
	* @var mixed passwordManagerInternal
	*/

	passwordManagerInternal: null,

	/*
	 * Constructor
	 *
	 * @return void
	 */

	load: function()
	{
		GrPref.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.google_reader_notifier.");
	    GrPref.passwordManagerInternal = Components.classes["@mozilla.org/passwordmanager;1"].createInstance( Components.interfaces.nsIPasswordManagerInternal );
    	GrPref.passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance( Components.interfaces.nsIPasswordManager );
		GrPref.defaultInterval = 300;
	},

	/**
	* Destructor
	*
	* @return void
	*/

	unload: function()
	{
		if(parseInt($('interval').value) < 120)
		{
			GrPref.prefs.setIntPref('interval', GrPref.defaultInterval);
		}

		//Guardamos la contraseña

		GrPref.setPassword($('password').value);

		//Petición de actualización

		var observer = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observer.notifyObservers(null, gGrNotifyUpdate, true);
	},

	/*
	 * Carga los campos del formulario, por ahora solo la contraseña
	 *
	 * @return void
	 */

	loadFields: function()
	{
		$('password').value = GrPref.getPassword();
		GrPref.setIconsThemes();
		GrPref.previewIconTheme();
	},

	/*
	 * Devuelve la contraseña
	 *
	 * @return string
	 */

	getPassword: function()
	{
	    var url = "chrome://google_reader_notifier/";
	    var host = {value:""};
	    var user =  {value:""};
	    var password = {value:""};

	    try
		{
	        GrPref.passwordManagerInternal.findPasswordEntry( url, "", "", host, user, password );
	    }
		catch( err ){}

	    return password.value;
	},

	/*
	 * Establece la contraseña
	 *
	 * @param string Contraseña
	 * @return void
	 */

	setPassword: function(password)
	{
        var url = "chrome://google_reader_notifier/";

        try
		{
            GrPref.passwordManager.removeUser( url, "" );
        }catch( err ){}

        try
		{
            GrPref.passwordManagerInternal.addUserFull( url, "", password, "", "" );
        } catch( err ){}
	},

	/*
	* Hay que volver a logearse ya que el usuario ha cambiado la cuenta
	*
	* @return void
	*/

	accountChanged: function()
	{
		GrPref.prefs.setCharPref('logged_SID', '');
	},

	/*
	* Indica si la cuenta del usuario existe
	*
	* @return bool
	*/

	accountExist: function()
	{
		if((GrPref.prefs.getCharPref('usermail')) && (GrPref.getPassword()))
		{
			return true;
		}

		return false;
	},

	/*
	 * Crea la lista de iconos disponibles
	 *
	 * @return void
	 */

	setIconsThemes: function()
	{
		var icons = [
						{dir: '3D', name: '3D'},
						{dir: 'default', name: 'Default Theme'},
						{dir: 'toolkit_orange', name: 'Google Reader Toolkit Orange'},
						{dir: 'toolkit_red', name: 'Google Reader Toolkit Red'}
					];

		var menupopup = document.createElement("menupopup");

		for(var i in icons)
		{
			var icon = document.createElement("menuitem");
			icon.setAttribute("value", icons[i]['dir']);
			icon.setAttribute("label", icons[i]['name']);

			menupopup.appendChild(icon);

			if(GrPref.prefs.getCharPref('icon_theme') == icons[i]['dir'])
			{
				var selectedIcon = icon;
			}
		}

		$('icon_theme').appendChild(menupopup);
		$('icon_theme').selectedItem = selectedIcon;
	},

	/*
	 * Función que previsualiza el tema de iconos seleccionado
	 *
	 * @return void
	 */

	previewIconTheme: function()
	{
 		var selected_theme;

		if($('icon_theme').selectedItem.value == undefined)
		{
			selected_theme = GrPref.prefs.getCharPref('icon_theme');
		}
		else
		{
			selected_theme = $('icon_theme').selectedItem.value;
		}

		$('gr-image-status-' + gGrNoItemsStatus).src = "chrome://google_reader_notifier/skin/" + selected_theme + "/" + gGrNoItemsStatus + ".png";
		$('gr-image-status-' + gGrNewItemsStatus).src = "chrome://google_reader_notifier/skin/" + selected_theme + "/" + gGrNewItemsStatus + ".png";
		window.sizeToContent();
	}
}